Skip to main content

Graph Question - Hard Level - Question 1

2246. Longest Path With Different Adjacent Characters

You are given a tree (i.e. a connected, undirected graph that has no cycles) rooted at node 0 consisting of n nodes numbered from 0 to n - 1. The tree is represented by a 0-indexed array parent of size n, where parent[i] is the parent of node i. Since node 0 is the root, parent[0] == -1.

You are also given a string s of length n, where s[i] is the character assigned to node i.

Return the length of the longest path in the tree such that no pair of adjacent nodes on the path have the same character assigned to them.

Constraints:

n == parent.length == s.length
1 <= n <= 10^5
0 <= parent[i] <= n - 1 for all i >= 1
parent[0] == -1
parent represents a valid tree.
s consists of only lowercase English letters.


Analysis

For this question, we need to construct a graph, or more specifically, a n-nary tree.

How to construct the graph/tree?

What we only know is the parent array. So we need to go through the parent array and construct the graph: for each node, save their children.

After having the graph/tree, we can do a bottom-up traversal, from which we can get the longest path starting with each node (with no pair of adjacent nodes the same).

For each node in the tree, the path could be the combination of the longest path + second longest path. So we can use a bottom-up dfs search to find this.

Pay attention to the return value of the dfs function, since we can only return the longest path starting with the node, not the combined one.

See the code below:

class Solution {
public:
    int longestPath(vector<int>& parent, string s) {
        int n = s.size(), root = -1, res = 1;
        vector<vector<int>> g(n);
        for(int i=0; i<n; ++i) {
            if(parent[i] == -1) {
                root = i;
                continue;
            }
            g[parent[i]].push_back(i);
        }
        dfs(root, g, s, res);
        return res;
    }
private:
    int dfs(int r, vector<vector<int>>& g, string& s, int& res) {
        priority_queue<int, vector<int>, greater<int>> pq;
        for(auto &a : g[r]) {
            int v = dfs(a, g, s, res);
            if(s[r] != s[a]) {
                pq.push(v);
                if(pq.size()>2) pq.pop();
            }
        }
        int sd = 0, ft = 0;
        if(pq.size()) {
            sd = pq.top();
            pq.pop();
        }
        if(pq.size()) {
            ft = pq.top();
            pq.pop();
        }
        res = max(res, 1 + sd + ft);
        return 1 + max(sd, ft);
    }
};




Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once. We

Binary Search - Hard Level - Question 3

Binary Search - Hard Level - Question 3 878. Nth Magical Number A positive integer is magical if it is divisible by either a or b. Given the three integers n, a, and b, return the nth magical number. Since the answer may be very large, return it modulo 10^9 + 7. Analysis: Let us consider some examples first. Example 1, a = 4, b = 2. If b is dividable by a, then all the numbers which is dividable by a should be dividable by b as well. So the nth magical number should be n*b; Example 2, a = 3, b = 2. The multiples of 2 are: 2, 4, 6, 8, 10, 12, ... The multiple of 3 are: 3, 6, 9, 12, ... So the overlap is related to the minimum common multiple between a and b, and we need to remove the overlap which is double-counted. So now, we make some conclusions: 1. the upper bound of the nth magical number should be n*b, where a is the smaller one (or b <= a); 2. there are n*b/a magical numbers smaller than n*b; 3. there are n*b/(minimum common multiple) overlaps. Thus, the overall count is: n +

Recursion - Example

Recursion - Example Leetcode 231  Power of Two Given an integer n, return true if it is a power of two. Otherwise, return false. An integer n is a power of two, if there exists an integer x such that n == 2^x Constraints: -2^31 <= n <= 2^31 - 1 Analysis: One way is to think about this question recursively: if n%2 == 1, then n must not be power of 2; if not, then we just need to consider whether (n/2) is a power of 2 or not. This is exactly the "same question with a smaller size"! It is trivial to figure out the base cases: if n == 0, return false; if n == 1, return true. See the code below: class Solution { public: bool isPowerOfTwo(int n) { // base cases if(n == 0) return false; if(n == 1) return true; // converging if(n%2 == 1) return false; return isPowerOfTwo(n/2); } }; If interested, there are some other ways to solve this problem. For example, using bit manipulation, we can have the following solution: class